#pragma once

/*
Nbv{[hf[^Rs[Ăf[^

̓Rs[
GDInh́H@rbg}bvGdiplus::Bitmap*^ɃRs[ĂH

*/

#define CP_CBDATA_UTF16	-1
#define CP_CBDATA_UTF16BE -2
#define CP_CBDATA_UNKNOWN -10


extern BOOL GetClipboardFormatNameString(UINT nCF, CString& strName, BOOL& bRegisteredFormat);
extern CString GetClipboardFormatNameString(UINT nCF);
extern CString FORMATETCAspect2String(DWORD dwAspect);
extern CString FORMATETCTymed2String(DWORD tymed);
extern CString FORMATETC2String(const FORMATETC& fmtetc);
extern CString FORMATETC2ShortString(const FORMATETC& fmtetc);
extern void FORMATETC2ShortStringArray(CArray<FORMATETC, FORMATETC&>& arrayFormats, CStringArray& arrayString);

class CCBDataCreateContext
{
public:
	COleDataObject* m_pDataObject;	// 荞݌BNULLȂNbv{[hB
	HPALETTE m_hPalette;			// pbgBx擾ƂȂȂ̂ŁuŏɁv荞ŃRs[Ă
	BOOL m_bPaletteCopied;			// pbgRs[ꂽBŎɉKv

	ULONGLONG m_cbTotal;			// tH[}bgŎ荞񂾃TCY

	CCBDataCreateContext(COleDataObject* m_pDataObject, class CCopyingDialog* pDlg);
	virtual ~CCBDataCreateContext();

	// ԕ\
	class CCopyingDialog* m_pDlg;

	void SetName(const CString& strName);
	void SetName(FORMATETC& fmtetc);
	BOOL IsCancelled();
	CString GetAbortText();
};

///////////////////////////////////

class CCBData : public CObject
{
	DECLARE_DYNAMIC(CCBData)
public:
	FORMATETC m_fmtetc;		// Nbv{[hf[^cfFormatȊO͓ĂȂ
	DWORD m_tymed;			// ۂɎ荞݂sTYMED

	CString m_strType;		// FileContents̃^Cv
	// ̃f[^̂Ƀt@ĆBCFSTR_FILECONTENTS[n]
	CString m_strFileName;
	CString m_strDispFileName;

	enum {
		icontypeFolder,
		icontypeFile,
		icontypeGdi,
		icontypeUnknown,
	};
	int m_nIconType;

	// ǉvpeB
	CStringArray m_arrayProperties;


	// HGLOBAL̒gRs[Ă
	ULONGLONG m_cbMem;
	CString m_strMemDataFileName;	// C[Wێt@C


	// FILECONTENTS̃Tuc[
	class CCBDataArray* m_pArrayChildren;

	// \̃qg
	enum {
		suitabletypeHex = 0,
		suitabletypeText,
		suitabletypeImage,
		suitabletypeProperty,
	};

	// ƃGA
	BOOL m_bPlaceHolder;
	IShellFolder* m_pShellFolder;
	IStorage* m_pStorage;

protected:
	int m_suitabletype;
public:
	int GetSuitableType();
	void SetSuitableType(int suitabletype);
protected:
	CString GetFormatTypeString();
	int m_nCodePage;	// eLXg\ɓKĂƎvR[hy[WB-1=UTF16 0=ANSI
public:
	int GetSuitableCodePage();
//	void SetSuitableCodePage(int nCodePage);

	static CCBData* Create(CCBDataCreateContext* pctx, FORMATETC& fmtetc);
	static CCBData* CreateSub(CCBDataCreateContext* pctx, FORMATETC& fmtetc, DWORD tymed);
	static CCBData* CreateFromHGlobal(CCBDataCreateContext* pctx, HGLOBAL);
	static CCBData* CreateFromFile(CCBDataCreateContext* pctx, const WCHAR* pszPathName);
	static CCBData* CreateFromIStream(CCBDataCreateContext* pctx, IStream* pStream);
	static CCBData* CreateFromIStorage(CCBDataCreateContext* pctx, IStorage* pStorage);
	static CCBData* CreateFromIShellFolder(CCBDataCreateContext* pctx, IShellFolder* pFolder);
	static CCBData* CreateFromDirectory(CCBDataCreateContext* pctx, const CString& strDir);
	static CCBData* CreateFromHBITMAP(HBITMAP hBitmap, HPALETTE hPalette);
	static CCBData* CreateFromMFPICT(HMETAFILEPICT hMetaFilePict);
	static CCBData* CreateFromHENHMETAFILE(HENHMETAFILE hEnhMetaFile);
	static CCBData* CreateDummyFolder(const CString& strType);
	static CCBData* CreateErrorData(const CString& strError);
	BOOL ParseHDrop(CCBDataCreateContext* pctx, BOOL bAddFiles);
	BOOL ParseShellIDList(CCBDataCreateContext* pctx);
	void ProcessFileContents();

public:
	CCBData();
	virtual ~CCBData();
	virtual void DeriveFrom(CCBData* pData);
	BYTE* LoadMemData();
	virtual Gdiplus::Image* GetImage(int& cx, int& cy, int& nBitsPerPixel);
	virtual void ReleaseImage(Gdiplus::Image* pImage);
	virtual CString GetTitle();

	friend class CCBDataArray;
};

///////////////////////////////////

class CCBData_FileDescriptor : public CCBData
{
	DECLARE_DYNAMIC(CCBData_FileDescriptor)
public:
	CStringArray m_arrayFileNames;
	CCBData_FileDescriptor();
	static CCBData_FileDescriptor* ChangeClassFrom(CCBData* pData) {CCBData_FileDescriptor* p = new CCBData_FileDescriptor; p->DeriveFrom(pData); return p;}
	virtual ~CCBData_FileDescriptor();
	BOOL ParseFileDescriptorW();
	BOOL ParseFileDescriptorA();
};

///////////////////////////////////

class CCBData_GDI : public CCBData
{
	DECLARE_DYNAMIC(CCBData_GDI)
public:
	int m_cxImage;
	int m_cyImage;
	int m_nBitsPerPixel;

	CCBData_GDI() : m_cxImage(0), m_cyImage(0), m_nBitsPerPixel(0) 
	{
		m_suitabletype = suitabletypeImage;
		m_nIconType = icontypeGdi;
	}
	virtual ~CCBData_GDI() {}
	virtual Gdiplus::Image* GetImage(int& cx, int& cy, int& nBitsPerPixel);
	virtual void ReleaseImage(Gdiplus::Image* pImage);
	// TuNXłI[o[Ch
	virtual Gdiplus::Image* GetImageSub() {return NULL;}
};

///////////////////////////////////

class CCBData_HBITMAP : public CCBData_GDI
{
	DECLARE_DYNAMIC(CCBData_HBITMAP)
public:
	HBITMAP m_hBitmap;
	HPALETTE m_hPalette;

	CCBData_HBITMAP();
	virtual ~CCBData_HBITMAP();
	void CopyImage(HBITMAP hbm, HPALETTE hPal);
	virtual Gdiplus::Image* GetImageSub();
};

///////////////////////////////////

class CCBData_HENHMF : public CCBData_GDI
{
	DECLARE_DYNAMIC(CCBData_HENHMF)
public:
	HENHMETAFILE m_hEM;

	CCBData_HENHMF();
	virtual ~CCBData_HENHMF();
	void CopyImage(HENHMETAFILE hEM);
	virtual Gdiplus::Image* GetImageSub();
};

///////////////////////////////////

class CCBData_HMETAFILEPICT : public CCBData_GDI
{
	DECLARE_DYNAMIC(CCBData_HMETAFILEPICT)
public:
	HMETAFILEPICT m_hMetaFilePict;	// O[o
	HMETAFILE m_hMF;				// ɂnh

	CCBData_HMETAFILEPICT();
	virtual ~CCBData_HMETAFILEPICT();
	void CopyImage(HMETAFILEPICT hMetaFilePict);
	virtual Gdiplus::Image* GetImageSub();
};

///////////////////////////////////

class CCBData_DIB : public CCBData
{
	DECLARE_DYNAMIC(CCBData_DIB)
protected:
	BYTE* m_pMem;

public:
	CCBData_DIB();
	virtual ~CCBData_DIB();
	static CCBData_DIB* ChangeClassFrom(CCBData* pData) {CCBData_DIB* p = new CCBData_DIB; p->DeriveFrom(pData); return p;}
	virtual Gdiplus::Image* GetImage(int& cx, int& cy, int& nBitsPerPixel);
	virtual void ReleaseImage(Gdiplus::Image* pImage);

};

///////////////////////////////////

class CCBData_DragImageBits : public CCBData
{
	DECLARE_DYNAMIC(CCBData_DragImageBits)
protected:
	BYTE* m_pMem;
public:
	CCBData_DragImageBits();
	virtual ~CCBData_DragImageBits();
	static CCBData_DragImageBits* ChangeClassFrom(CCBData* pData) {CCBData_DragImageBits* p = new CCBData_DragImageBits; p->DeriveFrom(pData); return p;}
	virtual Gdiplus::Image* GetImage(int& cx, int& cy, int& nBitsPerPixel);
	virtual void ReleaseImage(Gdiplus::Image* pImage);
};

class CCBDataArray : public CArray<CCBData*, CCBData*>
{
public:
	CCBDataArray() {}
	virtual ~CCBDataArray()
	{
		for (int i = 0; i < GetSize(); i++)
		{
			delete GetAt(i);
		}
	}

	// Cc[쐬
	static void EnumAllFormats(COleDataObject* pDataObject, CArray<FORMATETC, FORMATETC&>& arrayFormats);
	void CreateItems(COleDataObject* pDataObject, CArray<FORMATETC, FORMATETC&>& arrayFromats);
protected:
	CCBData_FileDescriptor* FindFileDescriptor(CCBData* pDataContents);
public:

	// Tuc[쐬
	void CreateSubTreeFromCIDA(CCBDataCreateContext* pctx, IShellFolder* pFolder, CIDA* pida);
	void CreateSubTreeFromIStorage(CCBDataCreateContext* pctx, IStorage* pStorage);
	void CreateSubTreeFromIShellFolder(CCBDataCreateContext* pctx, IShellFolder* pShellFolder);
	void CreateSubTreeFromDirectory(CCBDataCreateContext* pctx, const CString& strDir);
	void CreateSubTreeFromHDROP(CCBDataCreateContext* pctx, HDROP hdrop);
	void CreateSubTreeFromFileDescriptor(CCBDataCreateContext* pctx, CCBData_FileDescriptor* pDataDescriptor, FORMATETC& fmtetcContents);
};
