// DropEntranceWnd.cpp : t@C
//

#include "stdafx.h"
#include "ClipMM.h"
#include "DropEntranceWnd.h"
#include "ClipMMDoc.h"

// CDropEntranceWnd

IMPLEMENT_DYNAMIC(CDropEntranceWnd, CWnd)

CDropEntranceWnd::CDropEntranceWnd()
{

}

CDropEntranceWnd::~CDropEntranceWnd()
{
}

BOOL CDropEntranceWnd::Create(CWnd* pWndParent, UINT nID, COLORREF rgb, const CString& strText, DWORD_PTR dw1)
{
	m_rgb = rgb;
	m_strText = strText;
	m_dw1 = dw1;

	return 
	CWnd::Create(AfxRegisterWndClass(0, AfxGetApp()->LoadStandardCursor(IDC_ARROW)),
				L"",
				WS_CHILD | WS_BORDER,
				CRect(0, 0, 0, 0),
				pWndParent,
				nID);

}


BEGIN_MESSAGE_MAP(CDropEntranceWnd, CWnd)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_PAINT()
END_MESSAGE_MAP()



// CDropEntranceWnd bZ[W nh[




int CDropEntranceWnd::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	m_font.CreatePointFont(80, L"MS UI Gothic");

	m_odt.Register(this, this);

	return 0;
}


void CDropEntranceWnd::OnDestroy()
{
	CWnd::OnDestroy();

	// TODO: ɃbZ[W nh[ R[hǉ܂B
}

void CDropEntranceWnd::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	int nSavedDC = dc.SaveDC();

	CRect rc;
	GetClientRect(rc);

	dc.FillSolidRect(rc, m_rgb);//RGB(244, 255, 252));

	dc.SelectObject(&m_font);
	dc.SetTextColor(RGB(0, 0, 0));
	dc.SetBkColor(m_rgb);

	CRect rcExtent(rc);
	dc.DrawText(m_strText, (int)m_strText.GetLength(), rcExtent,
				DT_CALCRECT | DT_CENTER | DT_NOPREFIX);

	int cyText = rcExtent.Height();
	int y = (rc.Height() - cyText) / 2;
	int cxText = rcExtent.Width();
	int x = (rc.Width() - cxText) / 2;
	rcExtent.top += y;
	rcExtent.bottom += y;
	rcExtent.left += x;
	rcExtent.right += x;

	dc.DrawText(m_strText, (int)m_strText.GetLength(), rcExtent,
				DT_CENTER | DT_NOPREFIX);

	dc.RestoreDC(nSavedDC);
}

DROPEFFECT CDropEntranceWnd::OnDragEnter(COleDataObject* pDataObject, DWORD dwKeyState, CPoint point)
{

	return DROPEFFECT_COPY;
}
void CDropEntranceWnd::OnDragLeave()
{
}
DROPEFFECT CDropEntranceWnd::OnDragOver(COleDataObject* pDataObject, DWORD dwKeyState, CPoint point)
{

	return DROPEFFECT_COPY;
}
DROPEFFECT CDropEntranceWnd::OnDragScroll(DWORD dwKeyState, CPoint point)
{
	return DROPEFFECT_NONE;
}

BOOL CDropEntranceWnd::OnDrop(COleDataObject* pDataObject,	DROPEFFECT dropEffect, CPoint point)
{
	CDocument* pDoc = NULL;
	CFrameWnd* pFrame = GetParentFrame();
	if (pFrame)
	{
		CView* pView = pFrame->GetActiveView();
		if (pView)
		{
			pDoc = pView->GetDocument();
		}
	}
	if (pDoc->IsKindOf(RUNTIME_CLASS(CClipMMDoc)))
	{
		CClipMMDoc* pDoc1 = (CClipMMDoc*)pDoc;
		if (pDoc1->OnDataDrop(pDataObject, (BOOL)m_dw1))
			return DROPEFFECT_COPY;
	}

	return DROPEFFECT_NONE;
}

