#pragma once

template <typename TYPE>
class CGlobalPtr
{
public:
	HANDLE m_h;
	TYPE m_p;

	CGlobalPtr<TYPE>(HANDLE h)
		: m_h(h)
		, m_p(NULL)
	{
		m_p = (TYPE)GlobalLock(h);
	}

	~CGlobalPtr<TYPE>()
	{
		if (m_p)
			GlobalUnlock(m_h);
	}

	operator TYPE()
	{
		return m_p;
	}

	TYPE operator ->()
	{
		return m_p;
	}
};
