#include "stdafx.h"
#include "GuessCharSet.h"
//#include <ctype.h>

BOOL IsSJISLeadingByte(char c) {return _ismbblead(c);}

BOOL IsSJISTrailingByte(char c) {return _ismbbtrail(c);}

int IsUTF8LeadingByte(char c0)
{
	unsigned char c = c0;
	if ((c & 0x80) == 0)
		return 0;		// 1oCg
	else if ((c & 0xE0) == 0xC0)
		return 1;		// 2oCgR[hB1oCgtrailing
	else if ((c & 0xF0) == 0xE0)
		return 2;		
	else if ((c & 0xF8) == 0xF0)
		return 3;
	else
		return -1;
}

BOOL IsUTF8TrailingByte(char c)
{
	if (c & 0x80)
		return TRUE;
	else
		return FALSE;
}

size_t CountUTF8Errors(const char* psz, size_t cch)
{
	size_t nErrors = 0;

	int nState = 0;
	for (size_t i = 0; i < cch; i++)
	{
		char c = psz[i];
		if (nState <= 0)
		{
			if (!c)
				break;
			int n = IsUTF8LeadingByte(c);
			if (n < 0)
			{
				nErrors++;
				nState = 0;
			}
			else
			{
				nState = n;
			}
		}
		else
		{
			// 2oCgڈȍ~Ă͂B
			if (!c)
			{
				nErrors++;
				break;
			}
			if (!IsUTF8TrailingByte(c))
			{
				nErrors++;
			}
			nState--;
		}
	}
	return nErrors;
}

size_t CountSJISErrors(const char* psz, size_t cch)
{
	BOOL bKanji = FALSE;
	size_t nErrors = 0;

	for (size_t i = 0; i < cch; i++)
	{
		char c = psz[i];
		if (bKanji)
		{
			if (!c)
			{
				nErrors++;
				break;
			}
			if (!IsSJISTrailingByte(c))
				nErrors++;
			bKanji = FALSE;
		}
		else
		{
			if (!c)
				break;
			if (IsSJISLeadingByte(c))
			{
				bKanji = TRUE;
			}
		}
	}
	return nErrors;
}


BOOL GetSJISDoubleByteCharError(const char* psz, int cch)
{
	BOOL bError = FALSE;

	char* pchBuf = new char[cch+1];
	char* pchOut = pchBuf;

	BOOL bKanji = FALSE;

	for (int i = 0; i < cch; i++)
	{
		char c = psz[i];
		if (bKanji)
		{
			if (!c)
				break;
			*pchOut++ = c;
			bKanji = FALSE;
		}
		else
		{
			if (!c)
				break;
			if (IsSJISLeadingByte(c))
			{
				bKanji = TRUE;
				*pchOut++ = c;
			}
		}
	}
	if (bKanji)
		pchOut--;
	int cchBuf = (int)(pchOut - pchBuf);
	if (cchBuf > 0)
	{

		int cchUnicodeBuf = cchBuf + 1024;	// Ƃ蒷͂Ȃ܂
		WCHAR* pchUnicodeBuf = new WCHAR[cchUnicodeBuf + 1];

		if (MultiByteToWideChar(932, MB_ERR_INVALID_CHARS, pchBuf, cchBuf, 
							pchUnicodeBuf, cchUnicodeBuf) == 0)
		{
			if (GetLastError() == ERROR_NO_UNICODE_TRANSLATION)
			{
				bError = TRUE;
			}
		}
		delete[] pchUnicodeBuf;
	}
	delete[] pchBuf;

	return bError;

}
