// HexViewDialog.cpp : t@C
//

#include "stdafx.h"
#include "ClipMM.h"
#include "HexViewDialog.h"
#include "afxdialogex.h"

#define IDC_HEX 100

// CHexViewDialog _CAO

IMPLEMENT_DYNAMIC(CHexViewDialog, CClipMMPropertyPage)

CHexViewDialog::CHexViewDialog(CCBData* pData)
	: CClipMMPropertyPage(pData, CHexViewDialog::IDD)
{

}

CHexViewDialog::~CHexViewDialog()
{
}

void CHexViewDialog::DoDataExchange(CDataExchange* pDX)
{
	CClipMMPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_LINE_WIDTH, m_comboLineWidth);
	DDX_Control(pDX, IDC_EDIT_HEX, m_editHex);
}


BEGIN_MESSAGE_MAP(CHexViewDialog, CClipMMPropertyPage)
	ON_WM_SIZE()
	ON_CBN_SELCHANGE(IDC_COMBO_LINE_WIDTH, &CHexViewDialog::OnCbnSelchangeComboLineWidth)
END_MESSAGE_MAP()


// CHexViewDialog bZ[W nh[


void CHexViewDialog::OnSize(UINT nType, int cx, int cy)
{
	CClipMMPropertyPage::OnSize(nType, cx, cy);

	if (m_editHex.m_hWnd)
	{
		CRect rc;
		m_editHex.GetWindowRect(rc);
		ScreenToClient(rc);
		rc.right = cx;
		rc.bottom = cy;

		m_hexctrl.MoveWindow(rc);
	}
}

void CHexViewDialog::HexCtrlCallback(ULONGLONG pos, DWORD len, void* pBuf, DWORD_PTR dw1, DWORD_PTR dw2)
{
	CHexViewDialog* pThis = (CHexViewDialog*)dw1;
	if (pThis->m_fileMem.m_hFile != INVALID_HANDLE_VALUE)
	{
		pThis->m_fileMem.Seek(pos, CFile::begin);
		pThis->m_fileMem.Read(pBuf, len);
	}
}

BOOL CHexViewDialog::OnInitDialog()
{
	CClipMMApp* pApp = (CClipMMApp*)AfxGetApp();

	CClipMMPropertyPage::OnInitDialog();

	m_fileMem.Open(m_pData->m_strMemDataFileName, CFile::modeRead | CFile::shareDenyNone);

//	EnableThemeDialogTexture(m_hWnd, ETDT_DISABLE);

	m_fontFixedPitch.CreatePointFont(90, L"lr SVbN");
	m_editHex.SetFont(&m_fontFixedPitch);

	m_hexctrl.Create(WS_CHILD | WS_BORDER | WS_TABSTOP | WS_GROUP, this, IDC_HEX);
	CRect rc;
	m_editHex.GetWindowRect(rc);
	ScreenToClient(rc);
	m_hexctrl.MoveWindow(rc);
	m_hexctrl.ShowWindow(SW_SHOW);
	m_editHex.ShowWindow(SW_HIDE);

	int nWidth = pApp->GetProfileInt(L"Settings", L"HexViewWidth", 16);
	int n = 0;
	switch (nWidth)
	{
	case 16:
		n = 0;
		break;
	case 32:
		n = 1;
		break;
	case 64:
		n = 2;
		break;
	default:
		n = 0;
		nWidth = 16;
		break;
	}
	m_hexctrl.SetLineWidth(nWidth);

	if (m_pData)
	{
		m_hexctrl.SetData(m_pData->m_cbMem, HexCtrlCallback, (DWORD_PTR)this, NULL);
	}


	m_comboLineWidth.SetCurSel(n);

	m_hexctrl.SetWindowPos(&wndTop, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

void CHexViewDialog::OnCbnSelchangeComboLineWidth()
{
	CClipMMApp* pApp = (CClipMMApp*)AfxGetApp();

	int nLineWidth = 16;
	int n = m_comboLineWidth.GetCurSel();
	switch (n)
	{
	case 0:
		nLineWidth = 16;
		break;
	case 1:
		nLineWidth = 32;
		break;
	case 2:
		nLineWidth = 64;
		break;
	}
	int nWidth = pApp->WriteProfileInt(L"Settings", L"HexViewWidth", nLineWidth);

	m_hexctrl.SetLineWidth(nLineWidth);
}

void CHexViewDialog::OnToolSetDefaultView()
{
	if (m_pData)
		m_pData->SetSuitableType(CCBData::suitabletypeHex);
}
