// PropertyViewDialog.cpp : t@C
//

#include "stdafx.h"
#include "ClipMM.h"
#include "PropertyViewDialog.h"
#include "afxdialogex.h"
#include "util.h"
#include "GlobalPtr.h"

// CPropertyViewDialog _CAO

IMPLEMENT_DYNAMIC(CPropertyViewDialog, CClipMMPropertyPage)

CPropertyViewDialog::CPropertyViewDialog()
	: CClipMMPropertyPage(NULL, CPropertyViewDialog::IDD)
{

}

CPropertyViewDialog::~CPropertyViewDialog()
{
}

void CPropertyViewDialog::DoDataExchange(CDataExchange* pDX)
{
	CClipMMPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_PROPERTY, m_list);
}


BEGIN_MESSAGE_MAP(CPropertyViewDialog, CClipMMPropertyPage)
	ON_WM_SIZE()
	ON_NOTIFY(NM_RCLICK, IDC_LIST_PROPERTY, &CPropertyViewDialog::OnRclickListProperty)
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_EDIT_COPY, &CPropertyViewDialog::OnEditCopy)
	ON_COMMAND(ID_EDIT_COPY_ITEM_TITLE, &CPropertyViewDialog::OnEditCopyItemTitle)
	ON_COMMAND(ID_EDIT_COPY_ITEM_VALUE, &CPropertyViewDialog::OnEditCopyItemValue)
	ON_COMMAND(ID_EDIT_SELECT_ALL, &CPropertyViewDialog::OnEditSelectAll)
END_MESSAGE_MAP()


// CPropertyViewDialog bZ[W nh[


void CPropertyViewDialog::OnSize(UINT nType, int cx, int cy)
{
	CClipMMPropertyPage::OnSize(nType, cx, cy);

	if (m_list.m_hWnd)
	{
		CRect rc;
		rc.left = 0;
		rc.top = 0;
		rc.right = cx;
		rc.bottom = cy;

		m_list.MoveWindow(rc);
	}
}

void CPropertyViewDialog::SetData(CCBData* pData)
{
	m_pData = pData;
	CStringArray a;
	if (pData)
	{
		if (pData->m_fmtetc.cfFormat)
		{
			CString str;
			str = L"tH[}bg\t";
			str += GetClipboardFormatNameString(pData->m_fmtetc.cfFormat);
			str += L" (";
			str += UnsignedDecimalString(pData->m_fmtetc.cfFormat);
			str += L")";
			a.Add(str);
		}

		if (pData->m_fmtetc.lindex >= 0)
			a.Add(CString(L"Index\t") + UnsignedDecimalString(pData->m_fmtetc.lindex));

		if (!pData->m_strMemDataFileName.IsEmpty())
			a.Add(CString(L"TCY\t") + UnsignedLongLongDecimalString(pData->m_cbMem));

		CString strAspect = FORMATETCAspect2String(pData->m_fmtetc.dwAspect);
		if (!strAspect.IsEmpty())
			a.Add(CString(L"Aspect\t") + strAspect);

		CString strTymed = FORMATETCTymed2String(pData->m_fmtetc.tymed);
		if (!strTymed.IsEmpty())
			a.Add(CString(L"Tymed\t") + strTymed);

		CString strTymed2 = FORMATETCTymed2String(pData->m_tymed);
		if (!strTymed2.IsEmpty() && strTymed != strTymed2)
			a.Add(CString(L"{Tymed\t") + strTymed2);

		if (!pData->m_strType.IsEmpty())
			a.Add(CString(L"^Cv\t") + pData->m_strType);

		if (!pData->m_strFileName.IsEmpty())
			a.Add(CString(L"O\t") + pData->m_strFileName);

		if (!pData->m_strDispFileName.IsEmpty())
			a.Add(CString(L"\\t") + pData->m_strDispFileName);

		a.Append(pData->m_arrayProperties);
	}

	SetStringArray(a);

}

void CPropertyViewDialog::SetFormatNameArray(const CStringArray& arrayFormatNames)
{
	if (arrayFormatNames.GetSize() == 0)
	{
		return;
	}

	CStringArray arrayStr;
	arrayStr.Add(CString(L"tH[}bg\t") + arrayFormatNames[0]);
	for (int i = 1; i < arrayFormatNames.GetSize(); i++)
		arrayStr.Add(CString(L"\t") + arrayFormatNames[i]);

	SetStringArray(arrayStr);
}

void CPropertyViewDialog::SetStringArray(const CStringArray& arrayStr)
{
	m_list.DeleteAllItems();

	// ŏ̃^u܂łږ
	struct COLDATA {
		CString strName;
		CString strValue;
	};

	CArray<COLDATA*, COLDATA*> arrayLines;
	for (int i = 0; i < arrayStr.GetSize(); i++)
	{
		const CString& strLine = arrayStr[i];
		COLDATA* pLine = new COLDATA;
		int n = strLine.Find(L'\t');
		if (n >= 0)
		{
			pLine->strName = strLine.Left(n);
			pLine->strValue = strLine.Mid(n + 1);
		}
		else
		{
			pLine->strName = strLine;
		}
		arrayLines.Add(pLine);
	}

	for (int i = 0; i < arrayLines.GetSize(); i++)
	{
		m_list.InsertItem(i, arrayLines[i]->strName);
		m_list.SetItemText(i, 1, arrayLines[i]->strValue);
		delete arrayLines[i];
	}
}

BOOL CPropertyViewDialog::OnInitDialog()
{
	CClipMMApp* pApp = (CClipMMApp*)AfxGetApp();

	CClipMMPropertyPage::OnInitDialog();

	EnableThemeDialogTexture(m_hWnd, ETDT_ENABLETAB);

	m_list.SetExtendedStyle(m_list.GetExtendedStyle() | LVS_EX_FULLROWSELECT);

	{
		CClientDC dc(this);
		CFont* pFont = GetFont();
		CFont* pFontOld = dc.SelectObject(pFont);
		TEXTMETRIC tm;
		dc.GetTextMetrics(&tm);
		m_cxChar = tm.tmAveCharWidth;
		dc.SelectObject(pFontOld);
	}

	int cxCol0 = pApp->GetProfileInt(L"Frame", L"PropCol0", m_cxChar * 20);
	int cxCol1 = pApp->GetProfileInt(L"Frame", L"PropCol1", m_cxChar * 80);

	m_list.InsertColumn(0, L"", LVCFMT_LEFT, cxCol0, 0);
	m_list.InsertColumn(1, L"l", LVCFMT_LEFT, cxCol1, 1);


	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


void CPropertyViewDialog::OnRclickListProperty(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMITEMACTIVATE pNMItemActivate = reinterpret_cast<LPNMITEMACTIVATE>(pNMHDR);

	OnListContextMenu();

	*pResult = 0;
}


void CPropertyViewDialog::OnContextMenu(CWnd* /*pWnd*/, CPoint /*point*/)
{
//	OnListContextMenu();
}

void CPropertyViewDialog::OnListContextMenu()
{
	CMenu menu;
	menu.LoadMenu(IDR_PROPERTYVIEW_CONTEXT_MENU);
	CMenu* pPopupMenu = menu.GetSubMenu(0);

	CPoint pt;
	GetCursorPos(&pt);

	int nSelCount = m_list.GetSelectedCount();
	UINT mfCopy = nSelCount ? MF_ENABLED : MF_GRAYED;
	int nCount = m_list.GetItemCount();
	UINT mfSelAll = nCount ? MF_ENABLED : MF_GRAYED;
	pPopupMenu->EnableMenuItem(ID_EDIT_COPY, mfCopy);
	pPopupMenu->EnableMenuItem(ID_EDIT_COPY_ITEM_VALUE, mfCopy);
	pPopupMenu->EnableMenuItem(ID_EDIT_COPY_ITEM_TITLE, mfCopy);
	pPopupMenu->EnableMenuItem(ID_EDIT_SELECT_ALL, mfSelAll);
	
	pPopupMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON, pt.x, pt.y, this);	
}



void CPropertyViewDialog::OnEditCopy()
{
	CopyToClipboard(TRUE, TRUE);
}


void CPropertyViewDialog::OnEditCopyItemTitle()
{
	CopyToClipboard(TRUE, FALSE);
}


void CPropertyViewDialog::OnEditCopyItemValue()
{
	CopyToClipboard(FALSE, TRUE);
}

void CPropertyViewDialog::CopyToClipboard(BOOL bTitle, BOOL bValue)
{
	CString str;

	POSITION pos = m_list.GetFirstSelectedItemPosition();
	while (pos)
	{
		if (!str.IsEmpty())
			str += L"\r\n";

		int n = m_list.GetNextSelectedItem(pos);
		if (bTitle)
			str += m_list.GetItemText(n, 0);

		if (bTitle && bValue)
			str += L"\t";

		if (bValue)
			str += m_list.GetItemText(n, 1);
	}

	size_t cch = str.GetLength();
	size_t cbMem = (cch + 1) * sizeof(WCHAR);
	BOOL bMemSet = FALSE;
	HANDLE h = GlobalAlloc(GMEM_MOVEABLE | GMEM_ZEROINIT | GMEM_DDESHARE, cbMem);
	if (h)
	{
		CGlobalPtr<void*> pGlobal(h);
		if (pGlobal)
		{
			memcpy_s(pGlobal, cbMem, (const WCHAR*)str, cbMem);
			bMemSet = TRUE;
		}
	}

	if (bMemSet)
	{
		if (OpenClipboard())
		{
			EmptyClipboard();
			SetClipboardData(CF_UNICODETEXT, h);

			CloseClipboard();
			h = NULL;		// ̎qł͂ȂB
		}
		else
		{
			AfxMessageBox(L"Nbv{[hɏ߂܂B");
		}
	}
	else
	{
		AfxMessageBox(L"słB");
	}
	if (h)
		GlobalFree(h);
}


void CPropertyViewDialog::OnEditSelectAll()
{
	int n = m_list.GetItemCount();
	for (int i = 0; i < n; i++)
		m_list.SetItemState(i, LVIS_SELECTED, LVIS_SELECTED);
}

void CPropertyViewDialog::OnToolSetDefaultView()
{
	if (m_pData)
		m_pData->SetSuitableType(CCBData::suitabletypeProperty);
}

void CPropertyViewDialog::SavePersistentInfo()
{
	CClipMMApp* pApp = (CClipMMApp*)AfxGetApp();

	pApp->WriteProfileInt(L"Frame", L"PropCol0", m_list.GetColumnWidth(0));
	pApp->WriteProfileInt(L"Frame", L"PropCol1", m_list.GetColumnWidth(1));
}
