#include "stdafx.h"
#include "util.h"

CString StringFromStringArray(const CStringArray& arrayStr, const WCHAR* pszSeparator)
{
	if (pszSeparator == NULL)
		pszSeparator = L"\r\n";

	CString str;
	for (int i = 0; i < arrayStr.GetSize(); i++)
	{
		str += arrayStr[i] + pszSeparator;
	}
	return str;
}

CString StringFromStringArray(const WCHAR* arrayStr[], size_t nCount, const WCHAR* pszSeparator)
{
	if (pszSeparator == NULL)
		pszSeparator = L"\r\n";

	CString str;
	for (size_t i = 0; i < nCount; i++)
	{
		str += arrayStr[i];
		str += pszSeparator;
	}
	return str;
}

void StringArrayFromString(CStringArray& arrayStr, const WCHAR *pszStr, const WCHAR* pszSeparator)
{
	if (pszSeparator == NULL)
		pszSeparator = L"\r\n";
	int cchSeparator = (int)wcslen(pszSeparator);

	arrayStr.RemoveAll();
	const WCHAR* pch = pszStr;

	while (TRUE)
	{
		const WCHAR* pchFound = wcsstr(pch, pszSeparator);
		if (pchFound)
		{
			arrayStr.Add(CString(pch, (int)(pchFound - pch)));
			pch = pchFound + cchSeparator;
		}
		else
		{
			break;
		}
	}
	if (*pch)
	{
		arrayStr.Add(pch);
	}
}

CString UnsignedDecimalString(unsigned int n)
{
	CString str;
	str.Format(L"%u", n);
	return str;
}


CString UnsignedLongLongDecimalString(unsigned __int64 n)
{
	CString str;
	str.Format(L"%llu", n);
	return str;
}

CString SizeDecimalString(size_t n)
{
#ifdef _M_X64
	ASSERT(sizeof(size_t) == sizeof(__int64));
	CString str;
	str.Format(L"%llu", n);
	return str;

#else
	ASSERT(sizeof(size_t) == sizeof(int));
	CString str;
	str.Format(L"%u", n);
	return str;
#endif
}

CString DoubleAmp(const CString& str)
{
	CString strResult;
	for (int i = 0; i < str.GetLength(); i++)
	{
		if (str[i] == L'&')
			strResult += L"&&";
		else
			strResult += str[i];

	}
	return strResult;
}

CString MakePathName(const CString& strDir, const CString& strFile)
{
	if (strDir.Right(1) == L"\\")
		return strDir + strFile;
	else
		return strDir + L"\\" + strFile;
}

// g܂킵p\̃\[g֐

int __cdecl PSZ_PSZ_compare(const void* pv1, const void* pv2)
{
	const PSZ_PSZ* p1 = (const PSZ_PSZ*)pv1;
	const PSZ_PSZ* p2 = (const PSZ_PSZ*)pv2;

	return _wcsicmp(p1->psz1, p2->psz1);
}

int __cdecl UINT_PSZ_compare(const void* pv1, const void* pv2)
{
	const UINT_PSZ* p1 = (const UINT_PSZ*)pv1;
	const UINT_PSZ* p2 = (const UINT_PSZ*)pv2;

	if (p1->uint < p2->uint)
		return -1;
	else if (p1->uint > p2->uint)
		return 1;
	return 0;
}

int __cdecl PSZ_UINT_compare(const void* pv1, const void* pv2)
{
	const PSZ_UINT* p1 = (const PSZ_UINT*)pv1;
	const PSZ_UINT* p2 = (const PSZ_UINT*)pv2;

	return _wcsicmp(p1->psz, p2->psz);
}

